﻿#include "StdAfx.h"
#include "SettingAutoText.h"
#include "UIMenu.h"
#include "main_frame.hpp"
#include "NeMessengerDlg.h"
#include "CommonFunction.h"
#include "SettingAutoTextPopup.h"
#include "SettingFrame.hpp"


#define kSettingAutoText_Setting_ListView		_T("setting_autoText_listview")
#define kSettingAutoText_Setting_RichEdit		_T("setting_rich_edit")
#define AT_TEXT_PADDING					15
#define ITC_ITEM_TEXT_COLOR				0x666666
#define ITC_ITEM_LINE_COLOR				0xe9ebf5
#define ITC_HEADER_TEXT_COLOR			RGB(66,66,66)
#define ITC_HEADER_BORDER_COLOR			0xC5CACE

#define SAFEFREE_POINTER(x) if (x)delete x;x = NULL;


CSettingAutoText::CSettingAutoText(CSettingFrame* pSettingFrame)
{
	m_pList = NULL;
	m_pSettingFrame = pSettingFrame;
}

CSettingAutoText::~CSettingAutoText()
{
	
}

LPCTSTR CSettingAutoText::GetWindowClassName() const
{
	return _T("CSettingAutoText");
}


// void CSettingAutoText::Notify(TNotifyUI& msg)
// {
// 	if (msg.sType == DUI_MSGTYPE_SCROLL)
// 	{
// 		
// 	}
// 
// }

// int CSettingAutoText::SetState(DWORD dwStatus)
// {
// 	m_dwState = dwStatus;
// 	return 0;
// }

void CSettingAutoText::NotifyItemClick(TNotifyUI& msg)
{
	switch (msg.wParam)
	{
	case 3:	
		{
			if (NMessageBoxEx(m_pManager->GetPaintWindow(), LoadStringFromResource(IDS_STRING477), _T("Ntalk Biz"), MB_YESNO) == IDYES)
			{
				CAutoTextListElementUI *e = (CAutoTextListElementUI*)msg.pSender->GetInterface(AUTO_TEXT_TEXT_ELEMENT);
				if (e)
				{
					e->SetExtText(1,_T(""),_T(""),NULL);	
					e->SetExtEnable(msg.wParam,false);
					GET_CONFIG()->m_vecAutoText[e->GetTag()] = _T("");
					GET_CONFIG()->SaveAutoText();
				}
			}
			break;
		}
	case 2:
		{			
			CAutoTextListElementUI *e = (CAutoTextListElementUI*)msg.pSender->GetInterface(AUTO_TEXT_TEXT_ELEMENT);
			if (e)
			{	
				CSingleLock modalBoxCountLock(&g_csModalBoxCount);
				modalBoxCountLock.Lock();
				++g_ModalBoxCount;
				modalBoxCountLock.Unlock();

				CString strText = GET_CONFIG()->m_vecAutoText[e->GetTag()];
				CSettingAutoTextPopup dlg;
				dlg.SetRicheditText(strText);
				HWND hwnd = dlg.Create(m_pManager->GetPaintWindow(), _T("SettingAutoText"), WS_POPUPWINDOW, WS_EX_DLGMODALFRAME, CRect(0,0,270, 254));
				if (::IsWindow(hwnd))
				{
					dlg.CenterWindow();
					m_pSettingFrame->SetEnableFlash(FALSE);
                    GET_MESSENGER_DLG()->RegisterDuiModalWnd(&dlg);
                    int result = dlg.ShowModal();
                    GET_MESSENGER_DLG()->UnRegisterDuiModalWnd(&dlg);
					m_pSettingFrame->SetEnableFlash(TRUE);
					if (IDOK == result)
					{
						if (!dlg.GetRicheditText().IsEmpty())
						{
							RECT rc = {AT_TEXT_PADDING,0,AT_TEXT_PADDING,0};

							GET_CONFIG()->m_vecAutoText[e->GetTag()] = dlg.GetRicheditText();
							strText = dlg.GetRicheditText();
							strText.Replace(_T("\r"),_T(""));
							strText.Replace(_T("\n"),_T(""));
							e->SetExtText(1,strText,NULL,NULL,&rc);
							e->SetExtEnable(3,TRUE);
							GET_CONFIG()->SaveAutoText();
						}
					}

				}

				modalBoxCountLock.Lock();
				--g_ModalBoxCount;
				modalBoxCountLock.Unlock();
			}

			break;
		}
	case 1:
	case 0:
		break;
	}
}

void CSettingAutoText::InitListViewHeader()
{
	CHorizontalLayoutUI *pLayout = static_cast<CHorizontalLayoutUI*>(FindSubControl(_T("AutoTextHL")));  
	if (pLayout)
	{
		m_pList = new CAutoTextListUI();
		if (m_pList)
		{
			pLayout->Add(m_pList);

			m_pList->SetName(kSettingAutoText_Setting_ListView);
			m_pList->SetItemShowHtml(true);
			m_pList->SetItemLineColor(ITC_ITEM_LINE_COLOR);
			m_pList->SetItemTextColor(ITC_ITEM_TEXT_COLOR);
			m_pList->SetHotItemTextColor(ITC_ITEM_TEXT_COLOR);
			m_pList->SetHotItemBkColor(0xFFFFFF);
			m_pList->SetAttribute(_T("vscrollbar"),_T("true"));
			m_pList->SetAttribute(_T("hscrollbar"),_T("false"));
			m_pList->SetAttribute(_T("itemendellipsis"),_T("true"));	

			CAutoTextListHeaderUI *pListHeader = new CAutoTextListHeaderUI();
			if (pListHeader)
			{
				CAutoTextListHeaderItemUI *pListHeaderItem = new CAutoTextListHeaderItemUI();
				if (pListHeaderItem)
				{
					pListHeaderItem->SetFixedWidth(112);
					pListHeaderItem->SetTextColor(ITC_HEADER_TEXT_COLOR);
					pListHeaderItem->SetSepWidth(1);
					pListHeaderItem->SetText(LoadStringFromResource(IDS_STRING395));
					pListHeaderItem->SetAttribute(_T("align"),_T("left"));
					pListHeaderItem->SetSepImage(_T("lspimg.png"));
					pListHeaderItem->SetTextPadding(CRect(15,0,15,0));
					pListHeader->Add(pListHeaderItem);
					pListHeaderItem->SetOwner(pListHeader);
				}

				pListHeaderItem = new CAutoTextListHeaderItemUI();
				if (pListHeaderItem)
				{
					pListHeaderItem->SetFixedWidth(160);
					pListHeaderItem->SetTextColor(ITC_HEADER_TEXT_COLOR);
					pListHeaderItem->SetText(LoadStringFromResource(IDS_STRING481));
					pListHeaderItem->SetAttribute(_T("align"),_T("left"));
					pListHeaderItem->SetDragable(false);
					pListHeaderItem->SetTextPadding(CRect(15,0,15,0));
					pListHeader->Add(pListHeaderItem);
				}

				pListHeaderItem = new CAutoTextListHeaderItemUI();
				if (pListHeaderItem)
				{
					pListHeaderItem->SetFixedWidth(31);
					pListHeaderItem->SetTextColor(ITC_HEADER_TEXT_COLOR);
					pListHeaderItem->SetAttribute(_T("align"),_T("left"));
					pListHeaderItem->SetDragable(false);
					pListHeader->Add(pListHeaderItem);
				}

				pListHeaderItem = new CAutoTextListHeaderItemUI();
				if (pListHeaderItem)
				{
					pListHeaderItem->SetFixedWidth(31);
					pListHeaderItem->SetTextColor(ITC_HEADER_TEXT_COLOR);
					pListHeaderItem->SetAttribute(_T("align"),_T("left"));
					pListHeaderItem->SetDragable(false);
					pListHeader->Add(pListHeaderItem);
				}

				m_pList->Add(pListHeader);
				pListHeader->SetFixedHeight(30);
				pListHeader->SetBorderColor(ITC_HEADER_BORDER_COLOR);
				pListHeader->SetPadding(CRect(-1,0,0,0));
				pListHeader->SetBorderSize(CRect(0,0,0,2));
				pListHeader->SetBorderStyle(PS_SOLID);
			}
		}
	}


}
void CSettingAutoText::LoadListViewItem()
{
	CAutoTextListUI* pList = static_cast<CAutoTextListUI*>(FindSubControl(kSettingAutoText_Setting_ListView));  
	if (pList)
	{
		TCHAR szVal[24] = {0};
		std::vector<CString> &v = GET_CONFIG()->m_vecAutoText;
		for (int i = 1; i <= SC_DEFAULT_SIZE; i++)
		{	
			CAutoTextListElementUI* e = new CAutoTextListElementUI();  
			if (!e)
			{
				break;
			}

			e->SetFixedHeight(30);
			pList->Add(e); 
			
			int pos = i % SC_DEFAULT_SIZE;
			_stprintf(szVal,_T("Ctrl + %d"),pos);

			RECT rc = {AT_TEXT_PADDING,0,AT_TEXT_PADDING,0};
			e->SetExtText(0,szVal,NULL,NULL,&rc);		

			CString strText = v[pos];
			strText.Replace(_T("\r"),_T(""));
			strText.Replace(_T("\n"),_T(""));
			e->SetExtText(1,strText,NULL,NULL,&rc);
			e->SetExtText(2,_T("{i btn_setting_auto_add_nor.png}"),_T("{i btn_setting_auto_add_pre.png}"));
			e->SetExtText(3,_T("{i btn_setting_auto_del_nor.png}"),_T("{i btn_setting_auto_del_pre.png}"),_T("{i btn_setting_auto_del_disable.png}"));
			e->SetTag(pos);

			if (v[pos].GetLength() == 0)
			{
				e->SetExtEnable(3,false,false);
			}
		}

		for (int i = 1; i < SC_DEFAULT_SIZE; i++)
		{			
			CAutoTextListElementUI* e = new CAutoTextListElementUI();  
			if (!e)
			{
				break;
			}

			e->SetFixedHeight(30);
			pList->Add(e); 
			
			_stprintf(szVal,_T("Ctrl + Shit + %d"),i);

			RECT rc = {AT_TEXT_PADDING,0,AT_TEXT_PADDING,0};

			int pos = i + SC_DEFAULT_SIZE;
			e->SetExtText(0,szVal,NULL,NULL,&rc);
			CString strText = v[pos];
			strText.Replace(_T("\r"),_T(""));
			strText.Replace(_T("\n"),_T(""));
			e->SetExtText(1,strText,NULL,NULL,&rc);
			e->SetExtText(2,_T("{i btn_setting_auto_add_nor.png}"),_T("{i btn_setting_auto_add_pre.png}"));
			e->SetExtText(3,_T("{i btn_setting_auto_del_nor.png}"),_T("{i btn_setting_auto_del_pre.png}"),_T("{i btn_setting_auto_del_disable.png}"));
			e->SetTag(i + SC_DEFAULT_SIZE);

			if (v[pos].GetLength() == 0)
			{
				e->SetExtEnable(3,false,false);
			}
		}
	}
}

void CSettingAutoText::InitControl()
{ 
	CDialogBuilder builder;
	CContainerUI* pContainerUI = static_cast<CContainerUI*>(builder.Create(_T("setting_autoText.xml"), (UINT)0,NULL,m_pManager));
	if( pContainerUI != NULL ) 
	{
		this->Add(pContainerUI);
	}
	else 
	{
		this->RemoveAll();
		return;
	}


	InitListViewHeader();
	LoadListViewItem();
}

// void CSettingAutoText::OnPrepare(TNotifyUI& msg)
// {
// 	//UpdateFriendsList();
// 
// }

CDuiString CSettingAutoText::GetSkinFile()
{
	return _T("setting_autoText.xml");
}

CDuiString CSettingAutoText::GetSkinFolder()
{
	return _T("skin\\nTalkRes");
}


